package com.ashokit.transaction.service;

import javax.management.RuntimeErrorException;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import com.ashokit.transaction.model.Employee;
import com.ashokit.transaction.model.Insurance;


@Service
public class OrganizationService {
	
	
	@Autowired
	private EmployeeService empService;
	
	
	@Autowired
	private InsuranceService insService;
	
	@Transactional
	//Default behaviour is required ==> Full commit/Full Rollback
	//Requires_new ==> new propgation level ==> partial commit/partial rollback
	public void onBoardEmployee(Employee empObj,Insurance insObj) {
		
		//This line will save Employee Data to Employee Table
		empService.saveEmployee(empObj);
		
		if (insObj.getHealthInsuranceSchemeName().length() <= 5) {
			throw new RuntimeErrorException(null, "Insurance Scheme Name is Invalid");
			// Do i need to write rollback of employee delete in this case?
		} else {
			insObj.setEmpId(empObj.getEmpId()); // This will set EmployeeId to Insurance Obj
			insService.registerInsurance(insObj); //Save the Insurance Object
		}
		
		//hrservice
		//payrollservice
		//gratuityservie
		//pfservice
		//gitservice
		//timesheetserice
		//projectservice
		//bankaccountservice
		
		//AuditService ==> dont rollback audit service //partial commit/partial rollback
		 
		
	}

}
